<template>
  <v-tooltip location="bottom" text="Rolle löschen">
    <template v-slot:activator="{ props }">
      <v-btn
        v-bind="props"
        icon="mdi-trash-can"
        density="comfortable"
        variant="text"
        color="error"
        @click="showDialog = true"
      ></v-btn>
    </template>
  </v-tooltip>

  <v-dialog v-model="showDialog" max-width="600">
    <v-card
      prepend-icon="mdi-minus"
      text="Möchtest du diese Rolle wirklich löschen?"
      title="Rolle löschen?"
    >
      <template v-slot:actions>
        <div class="d-flex flex-row justify-space-between w-100">
          <v-btn text="Abbrechen" color="error" @click="showDialog = undefined"></v-btn>

          <v-btn text="Entgültig löschen" color="success" @click="submit()"></v-btn>
        </div>
      </template>
    </v-card>
  </v-dialog>
</template>

<script setup lang="ts">
import { ref } from "vue";
import { api, RoleResponse } from "../api";

const props = defineProps<{ role: RoleResponse }>();

const emits = defineEmits<{ (event: "submitted"): void }>();

const showDialog = ref<boolean>(false);

function submit(): void {
  api.roles
    .deleteRole(props.role.id)
    .then(() => {
      emits("submitted");
      showDialog.value = false;
    })
    .catch((error) => {
      console.error(error);
    });
}
</script>
